Attribute VB_Name = "mVBSqlite"
'mVBSqlite (bas)
'mSQLite - (mSqLite.bas) public module
'/////////////////////////////////////////////////////////////////////////////////////
'// Declares and public routines for VBSqlite - Visual BASIC
'// Copyright (C) M Shaw - 2008 - Freeware - NO WARRANTY WHATSOEVER
'// Website: http://vbtoolbox.amadis.sytes.net (sqlite.htm)
'/////////////////////////////////////////////////////////////////////////////////////
'// Versions:
'// v1.00 21/07/2008 First version sqlite_get_table
'// v1.01 22/07/2008 bugfixes
'// v1.02 25/07/2008 sqlite_exec, sqlite_progress_handler callback for DBQuery
'// v1.03 26/07/2008 sqlite_exec now accumulates rows via indirect string array
'//                  unicode support in the DLL (switchable via SetUnicodeConversion())
'// v1.04 28/07/2008 exec_query_unicode, sqlite_get_table_unicode, IsUsingUnicodeConversion
'//
'/////////////////////////////////////////////////////////////////////////////////////

Option Explicit
Option Base 0

' Application-specific constants
Public Const APPVERSION = "1.04"
Public Const VERDATE = "28th July 2008"
Public Const AUTHOR = "M Shaw"
Public Const DLLNAME = "VBSQLite.dll"
Public Const EXENAME = "VBSQLite"
Public Const APPEXENAME = "VBSQLite.exe"
Public Const WEBSITE = "http://vbtoolbox.amadis.sytes.net" ' Host site for this file
Public Const SQLITE_WEBSITE = "http://www.sqlite.org" ' The SQLite website

' Constants for using sqlite_open_v2()
Public Const SQLITE_OPEN_READONLY = 1
Public Const SQLITE_OPEN_READWRITE = 2
Public Const SQLITE_OPEN_CREATE = 4

' Handle a small selection of useful and relevant errors for us to handle
Public Const SQLITE_OK = 0
Public Const SQLITE_ERROR = 1
Public Const SQLITE_ABORT = 4
Public Const SQLITE_BUSY = 5
Public Const SQLITE_LOCKED = 6
Public Const SQLITE_INTERRUPT = 9
Public Const SQLITE_NOTFOUND = 12
Public Const SQLITE_AUTH = 23
Public Const SQLITE_NOTADB = 26
Public Const SQLITE_DONE = 101

Public CancelSQLQuery As Boolean    ' Global cancel flag - Set to True to cancel via Foo()

' SQLite error codes (full list)
'#define SQLITE_OK           0   // Successful result
'// beginning-of-error-codes
'#define SQLITE_ERROR        1   // SQL error or missing database
'#define SQLITE_INTERNAL     2   // Internal logic error in SQLite
'#define SQLITE_PERM         3   // Access permission denied
'#define SQLITE_ABORT        4   // Callback routine requested an abort
'#define SQLITE_BUSY         5   // The database file is locked
'#define SQLITE_LOCKED       6   // A table in the database is locked
'#define SQLITE_NOMEM        7   // A malloc() failed
'#define SQLITE_READONLY     8   // Attempt to write a readonly database
'#define SQLITE_INTERRUPT    9   // Operation terminated by sqlite3_interrupt()
'#define SQLITE_IOERR       10   // Some kind of disk I/O error occurred
'#define SQLITE_CORRUPT     11   // The database disk image is malformed
'#define SQLITE_NOTFOUND    12   // NOT USED. Table or record not found
'#define SQLITE_FULL        13   // Insertion failed because database is full
'#define SQLITE_CANTOPEN    14   // Unable to open the database file
'#define SQLITE_PROTOCOL    15   // NOT USED. Database lock protocol error
'#define SQLITE_EMPTY       16   // Database is empty
'#define SQLITE_SCHEMA      17   // The database schema changed
'#define SQLITE_TOOBIG      18   // String or BLOB exceeds size limit
'#define SQLITE_CONSTRAINT  19   // Abort due to constraint violation
'#define SQLITE_MISMATCH    20   // Data type mismatch
'#define SQLITE_MISUSE      21   // Library used incorrectly
'#define SQLITE_NOLFS       22   // Uses OS features not supported on host
'#define SQLITE_AUTH        23   // Authorization denied
'#define SQLITE_FORMAT      24   // Auxiliary database format error
'#define SQLITE_RANGE       25   // 2nd parameter to sqlite3_bind out of range
'#define SQLITE_NOTADB      26   // File opened that is not a database file
'#define SQLITE_ROW         100  // sqlite3_step() has another row ready
'#define SQLITE_DONE        101  // sqlite3_step() has finished executing

' SQLite functions
Public Declare Function sqlite3_libversion Lib "vbsqlite3.dll" () As String
Public Declare Function sqlite3_libversion_number Lib "vbsqlite3.dll" () As Long
Public Declare Function sqlite3_open Lib "vbsqlite3.dll" (ByVal FileName As String, _
    ByRef DB_Handle As Long) As Integer
Public Declare Function sqlite3_open_v2 Lib "vbsqlite3.dll" (ByVal FileName As String, _
    ByRef DB_Handle As Long, ByVal Flags As Integer, Optional ByVal zVfs As String = vbNullString) As Integer
Public Declare Function sqlite3_close Lib "vbsqlite3.dll" (ByRef DB_Handle As Long) As Integer

'Public Declare Sub sqlite_interrupt Lib "vbsqlite3.dll" (ByVal DB_Handle As Long)
'Public Declare Function sqlite_busy_timeout Lib "vbsqlite3.dll" (ByVal DB_Handle As Long, _
'    ByVal MilliSeconds As Integer) As Integer

Public Declare Function sqlite3_last_insert_rowid Lib "vbsqlite3.dll" (ByVal DB_Handle As Long) As Long ' Untested
Public Declare Function sqlite3_changes Lib "vbsqlite3.dll" (ByVal DB_Handle As Long) As Long   ' Untested

Public Declare Function sqlite_get_table Lib "vbsqlite3.dll" ( _
    ByVal DB_Handle As Long, _
    ByVal SQLString As String, _
    ByRef SQLErrorString As String, _
    ByRef SQLReturnCode As Integer) As Variant
    
' Must call SQLString using StrPtr(SQLString & vbNullChar)
Public Declare Function sqlite_get_table_unicode Lib "vbsqlite3.dll" ( _
    ByVal DB_Handle As Long, _
    ByVal SQLString As Long, _
    ByRef SQLErrorString As String, _
    ByRef SQLReturnCode As Integer) As Variant
        
'Callback interrupt register function for sqlite_get_table() et. al.
' Registers a VB Function as a callback-handler
' WARNING: DB_HANDLE must be ByBal here or the callback funct will not call (tested!)
Public Declare Sub sqlite_progress_handler Lib "vbsqlite3.dll" ( _
    ByVal DB_Handle As Long, _
    ByVal OpcodeCount As Integer, _
    ByVal pCallbackFunct As Any)

' VB Callback function signature for the sqlite_progress_handler to call - should be...
' Public Function SQLiteProgressCallback() As Integer
' Register in Visual BASIC using this code ... (N< say 100)
' sqlite_progress_handler DB,25,AddressOf SQLiteProgressCallback

' C/DLL wrapper signature ...
'void _stdcall sqlite_progress_handler(sqlite3* db,
'            int opcode_count,
'            long pFunct,                                // Optional callback function-pointer (may be NULL)
'            void* pArg)
    
'int sqlite_exec(sqlite3* db,                   // Wrapper for sqlite3_exec()
'    LPCSTR pszSql,                             // The SQL query string
'    void* pFunct,                              // Optional callback function-pointer (may be NULL)
'    void* pArg,                                // Argument for the f/p
'    LPCSTR* ErrMsg,                            // Returned error message (if any)
'    int* rc)                                   // SQLite return code

' funct call must be addressof(function) where function is int (*callback)(void*,int,char**,char**)
' e.g. Function Foo(pArgument as Any, ByRef Cols as Integer, ByRef sValues() as String, ByRef sNames() as String) as Integer
' pCallbackFunct *must* be ByVal and As Any - change at your peril!
'
Public Declare Function sqlite_exec Lib "vbsqlite3.dll" ( _
    ByVal DB_Handle As Long, _
    ByVal SQLString As String, _
    ByVal pCallbackFunct As Any, _
    ByRef pArgument As Any, _
    ByRef SQLErrorString As String) As Integer
    
' Must call SQLString using StrPtr(SQLString & vbNullChar)
Public Declare Function sqlite_exec_unicode Lib "vbsqlite3.dll" ( _
    ByVal DB_Handle As Long, _
    ByVal SQLString As Long, _
    ByVal pCallbackFunct As Any, _
    ByRef pArgument As Any, _
    ByRef SQLErrorString As String) As Integer
    
' Undocumented VB feature(s) required for sqlite_exec_unicode in order to pass Unicode strings
' Built-in by ordinal. Should be no need to declare (but not documented in VB5)
'Declare Function VarPtr Lib "msvbvm50.dll" (Var As Any) As Long
'Declare Function StrPtr Lib "msvbvm50.dll" (Var As Any) As Long

'Row counter functs - may be changed later or merged as one
Public Declare Function sqlite_query_rowcount Lib "vbsqlite3.dll" () As Long
Public Declare Function sqlite_exec_rowcount Lib "vbsqlite3.dll" () As Long

' Toolbox VB5+ functions
Public Declare Function GetArrayDimensions Lib "vbsqlite3.dll" (ByRef V As Variant) As Long
Public Declare Function GetArrayRows Lib "vbsqlite3.dll" (ByRef V As Variant) As Long
Public Declare Sub SetUnicodeConversion Lib "vbsqlite3.dll" (ByVal BoolState As Boolean)
Public Declare Function IsUsingUnicodeConversion Lib "vbsqlite3.dll" () As Boolean

' DLL Version control
Public Declare Function VBSQLLibTimeStamp Lib "vbsqlite3.dll" () As String  ' Full 26-char compile timestamp
Public Declare Function VBSQLLibVersion Lib "vbsqlite3.dll" () As Integer   ' Divide by 100 to get actual version
Public Declare Function MSVCVersion Lib "vbsqlite3.dll" () As Integer       ' Divide by 100 to get actual version


